import { test, expect, Page } from '@playwright/test';
import { strictEqual } from 'assert';

let page: Page;

test.beforeAll(async ({ browser }) => {
  page = await browser.newPage();
});

test.afterAll(async () => {
  if (page !== undefined) {
    await page.close();
  }
});

test('Login', async () => {
  // Login
  await page.goto('http://192.168.1.90:20001/');
  await expect(page).toHaveTitle(/^Sign in to /);
  await page.fill("input[name='username']", 'admin');
  await page.fill("input[name='password']", '1234');
  await page.click('id=kc-login');
  await page.waitForTimeout(2000);
  //   await page.click('id=acceptBtn');
});

test('Create Sub-Branch Managenment - ในกรณีที่ไม่กรอกข้อมูล', async () => {
  await page.click('id=menu-icon-branch-management');
  await page.click('id=create-sub-branch-btn-บริษัท โคโม่ จำกัด');
  await page.click("(//button[@type='submit'])[1]");
  await page.click('id=btn-form-submit');

  const taxNoError = page.locator(
    "(//div[@class='q-field__messages col']//div)[1]",
  );
  const nameError = page.locator(
    "(//div[@class='q-field__messages col']//div)[2]",
  );
  const nameEnError = page.locator(
    "(//div[@class='q-field__messages col']//div)[3]",
  );
  const lincenseNumberError = page.locator(
    "(//div[@class='q-field__messages col']//div)[4]",
  );
  const addressError = page.locator(
    "(//div[@class='q-field__messages col']//div)[5]",
  );
  const provinceError = page.locator(
    "(//div[@class='q-field__messages col']//div)[6]",
  );
  const districtError = page.locator(
    "(//div[@class='q-field__messages col']//div)[7]",
  );
  const subDistrictError = page.locator(
    "(//div[@class='q-field__messages col']//div)[8]",
  );
  const addressEnError = page.locator(
    "(//div[@class='q-field__messages col']//div)[9]",
  );

  await expect(taxNoError).toHaveText('จำเป็นต้องกรอกข้อมูลนี้');
  await expect(nameError).toHaveText('จำเป็นต้องกรอกข้อมูลนี้');
  await expect(nameEnError).toHaveText('จำเป็นต้องกรอกข้อมูลนี้');
  await expect(lincenseNumberError).toHaveText('จำเป็นต้องกรอกข้อมูลนี้');
  await expect(addressError).toHaveText('จำเป็นต้องกรอกข้อมูลนี้');
  await expect(provinceError).toHaveText('โปรดเลือกจังหวัด');
  await expect(districtError).toHaveText('โปรดเลือกอำเภอ');
  await expect(subDistrictError).toHaveText('โปรดเลือกตำบล');
  await expect(addressEnError).toHaveText('จำเป็นต้องกรอกข้อมูลนี้');

  await page.waitForTimeout(4000);
  await page.click('id=btn-form-cancel');
  console.log('การตรวจสอบ Validation ถูกต้อง');
});

test('Create Sub-Branch Managenment - ในกรณีที่กรอกทะเบียนนิติบุคคลเลขที่ไม่ครบ 13 หลัก', async () => {
  await page.reload();
  await page.click('id=create-sub-branch-btn-บริษัท โคโม่ จำกัด');
  await page.click("(//button[@type='submit'])[1]");
  await page.fill("(//input[@id='input-tax-no'])[2]", '123');

  // ตรวจสอบการแจ้งเตือนของทะเบียนนิติบุคคลเลขที่ในกรณีที่กรอกข้อมูลไม่ครบ 13 หลัก
  const taxNoError = page.locator(
    "(//div[@class='q-field__messages col']//div)[1]",
  );

  await expect(taxNoError).toHaveText(
    'ข้อมูลไม่ถูกต้อง กรุณากรอกให้ครบ 13 หลัก',
  );

  await page.waitForTimeout(4000);
  await page.click('id=btn-form-cancel');
  console.log(
    'ตรวจสอบการแสดง Vidation แจ้งเตือนในกรณีที่กรอกทะเบียนนิติบุคคลเลขที่ไม่ครบ 13 หลักถูกต้อง',
  );
});

test('Create Sub-Branch Managenment - กรอกอีเมลในกรณีที่ไม่ตรงรูปแบบอีเมล', async () => {
  await page.reload();
  await page.click('id=create-sub-branch-btn-บริษัท โคโม่ จำกัด');
  await page.click("(//button[@type='submit'])[1]");
  await page.fill("(//input[@id='input-email'])[2]", 'email');

  // ตรวจสอบการแจ้งเตือนของทะเบียนนิติบุคคลเลขที่ในกรณีที่กรอกข้อมูลไม่ครบ 13 หลัก
  const emailError = page.locator(
    "(//div[@class='q-field__messages col']//div)[2]",
  );

  await expect(emailError).toHaveText('ข้อมูลไม่ถูกต้อง');

  await page.waitForTimeout(4000);
  await page.click('id=btn-form-cancel');
  console.log(
    'ตรวจสอบการแสดง Vidation แจ้งเตือนในกรณีที่กรอกอีเมลไม่ตรงรูปแบบถูกต้อง',
  );
});
